Action for top-level dropdown menu item not activated

Bug #637692 reported by Jim Nelson on 2010-09-14
28
This bug affects 5 people
Affects Status Importance Assigned to Milestone
Application Menu Indicator
Fix Released
High
Ted Gould
Ayatana Ubuntu
High
Unassigned
DBus Menu
Fix Released
Undecided
Ted Gould
Indicator Applet
Fix Released
Undecided
Ted Gould
Shotwell
Fix Released
Unknown
Unity
Fix Released
High
Neil J. Patel
libindicator
Fix Released
Undecided
Ted Gould
awn-extras-applets (Ubuntu)
Undecided
Unassigned
cairo-dock-plugins (Ubuntu)
Undecided
Unassigned
indicator-applet (Ubuntu)
Undecided
Unassigned
indicator-application (Ubuntu)
Undecided
Unassigned
indicator-appmenu (Ubuntu)
Undecided
Unassigned
indicator-datetime (Ubuntu)
Undecided
Unassigned
indicator-me (Ubuntu)
Undecided
Unassigned
indicator-messages (Ubuntu)
Undecided
Unassigned
indicator-network (Ubuntu)
Undecided
Unassigned
indicator-session (Ubuntu)
Undecided
Unassigned
indicator-sound (Ubuntu)
Undecided
Unassigned
libdbusmenu (Ubuntu)
Undecided
Unassigned
libindicator (Ubuntu)
Undecided
Unassigned
lxpanel (Ubuntu)
Undecided
Unassigned
ubiquity (Ubuntu)
Undecided
Unassigned
unity (Ubuntu)
Undecided
Unassigned
xfce4-indicator-plugin (Ubuntu)
Undecided
Unassigned

Bug Description

Top-level menu items (File, Edit, View, Help, etc.) can have a GtkAction associated with them. The action is activated when the user clicks on the menu item to display the dropdown menu.

Shotwell uses this signal to sensitize menu items depending on program state. (Later we began moving to a pure GtkAction-based system, where we sensitize the Action and not the menu Widgets based on changes to internal state, but that work is incomplete.)

Under vanilla GNOME, this works fine today. Under Unity, the toplevel menu action is not fired when the user clicks on the item. This leaves our menu in its initial state no matter what the user does (i.e. they select a photo but none of the Photos items are sensitive).

I've provided a small test program (in Vala 0.9.8) that demonstrates this problem. To compile:

$ valac test.vala --pkg=gtk+-2.0

Related branches

Jim Nelson (yorba-jim) wrote :
Changed in shotwell:
status: Unknown → New
David Barth (dbarth) on 2010-09-14
Changed in unity:
assignee: nobody → Neil J. Patel (njpatel)
importance: Undecided → High
milestone: none → 2010-09-22
David Barth (dbarth) on 2010-09-15
Changed in unity:
milestone: 2010-09-22 → 2010-09-16
Changed in unity:
status: New → Confirmed
Ted Gould (ted) on 2010-09-16
Changed in libindicator:
assignee: nobody → Ted Gould (ted)
milestone: none → 0.3.14
Changed in indicator-applet:
assignee: nobody → Ted Gould (ted)
milestone: none → 0.4.6
Changed in indicator-appmenu:
assignee: nobody → Ted Gould (ted)
milestone: none → 0.0.12
Neil J. Patel (njpatel) wrote :

Need to move it over to next week as ted has some work to do in indicat* to make this work.

Changed in unity:
milestone: 2010-09-16 → 2010-09-22
Ted Gould (ted) on 2010-09-17
Changed in indicator-appmenu:
status: New → In Progress
Changed in libindicator:
status: New → In Progress
Ted Gould (ted) on 2010-09-17
Changed in dbusmenu:
status: New → In Progress
assignee: nobody → Ted Gould (ted)

I can confirm this as well. The menu works fine unless I am using the appmenu.

David Barth (dbarth) on 2010-09-21
Changed in ayatana-ubuntu:
importance: Undecided → High
milestone: none → ubuntu-10.10
status: New → In Progress
David Barth (dbarth) wrote :

This is a request for a Feature Freeze Exception, per https://wiki.ubuntu.com/FreezeExceptionProcess#General Instructions

Change description: The change is to allow applications using a particular kind of dynamic menus, like Shotwell, to have their menus properly exposed on the new panel menu.
Rationale for the exception: Without the change, all of Shotwell's menus are displayed and active, whereas only a few of them should be present. Without the change, the UI of Shotwell is severely impacted. Shotwell is the default photo management application for Ubuntu Maverick.
Additional information: the change requires fixes in several packages like unity, dbusmenu or libindicator; the libindicator change creates an ABI incompatibility as we ran out of free function slots in the object interface; this change in turns requires a rebuild of all indicators (~25) but not applications using the app-indicator protocol.

Ted Gould (ted) on 2010-09-21
Changed in libindicator:
status: In Progress → Fix Released
David Barth (dbarth) on 2010-09-21
Changed in indicator-appmenu:
importance: Undecided → High
Ted Gould (ted) wrote :

To clarify David's comment, I think he has a typo. There is roughly 8 source packages, not 25. It should only require rebuilding indicator-session, indicator-application, indicator-me, indicator-datetime, indicator-sound, indicator-messages, indicator-applet and unity. And indicator-network in universe.

Changed in indicator-appmenu:
status: In Progress → Fix Committed
Changed in dbusmenu:
status: In Progress → Fix Committed
Changed in indicator-applet:
status: New → Fix Committed
Changed in dbusmenu:
milestone: none → 0.3.15
Martin Pitt (pitti) wrote :

This indeed is a nasty issue, and 8 rebuilds (of small packages) sounds feasible. Please go ahead.

Didier Roche (didrocks) wrote :

thanks pitti, I'm adding tasks for package to be rebuilt

Didier Roche (didrocks) wrote :

it's a little bit more than 8 packages, there are in addition to ted's comment:

xfce4-indicator-plugin, lxpanel, cairo-dock-plug-ins, ubiquity

Julien Lavergne (gilir) wrote :

Adding also awn-extras which have indicators support.

Ted Gould (ted) on 2010-09-22
Changed in dbusmenu:
status: Fix Committed → Fix Released
Didier Roche (didrocks) on 2010-09-22
Changed in xfce4-indicator-plugin (Ubuntu):
status: New → Fix Committed
Changed in cairo-dock-plugins (Ubuntu):
status: New → Fix Committed
Ted Gould (ted) on 2010-09-22
Changed in indicator-applet:
status: Fix Committed → Fix Released
Ted Gould (ted) on 2010-09-22
Changed in indicator-appmenu:
status: Fix Committed → Fix Released
Didier Roche (didrocks) on 2010-09-22
Changed in libindicator (Ubuntu):
status: New → Fix Committed
Changed in indicator-applet (Ubuntu):
status: New → Fix Committed
Didier Roche (didrocks) on 2010-09-22
Changed in indicator-datetime (Ubuntu):
status: New → Fix Committed
Didier Roche (didrocks) on 2010-09-22
Changed in indicator-me (Ubuntu):
status: New → Fix Committed
Changed in indicator-network (Ubuntu):
status: New → Fix Committed
Changed in indicator-messages (Ubuntu):
status: New → Fix Committed
Changed in indicator-sound (Ubuntu):
status: New → Fix Committed
Didier Roche (didrocks) on 2010-09-22
Changed in indicator-session (Ubuntu):
status: New → Fix Committed
Changed in libdbusmenu (Ubuntu):
status: New → Fix Committed
Neil J. Patel (njpatel) on 2010-09-22
Changed in unity:
status: Confirmed → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package xfce4-indicator-plugin - 0.0.1-2build1

---------------
xfce4-indicator-plugin (0.0.1-2build1) maverick; urgency=low

  * Rebuild for libindicator ABI change (LP: #637692)
  * debian/control: depends on latest libindicator-dev
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 11:33:06 +0200

Changed in xfce4-indicator-plugin (Ubuntu):
status: Fix Committed → Fix Released
Didier Roche (didrocks) on 2010-09-22
Changed in indicator-application (Ubuntu):
status: New → Fix Committed
Changed in indicator-appmenu (Ubuntu):
status: New → Fix Committed
Didier Roche (didrocks) on 2010-09-22
Changed in unity (Ubuntu):
status: New → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libindicator - 0.3.14-0ubuntu1

---------------
libindicator (0.3.14-0ubuntu1) maverick; urgency=low

  * New upstream release.
    * Adding a function to signal a menu is shown (LP: #637692)
    * Changing indicator directory to '4'
  * debian/source:
    - don't use quilt format, it's making the daily build not working
  * debian/control:
    - rename to soname bump
    - put the Vcs-Bzr to point the right official branch
  * debian/libindicator1.install: rename to soname bump
  * debian/rules:
    - update MAKESHLIBS_ARGS

  [Ted Gould]
  * debian/rules:
    - removing simple-patchsys
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 18:09:44 +0200

Changed in libindicator (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package indicator-applet - 0.4.6-0ubuntu1

---------------
indicator-applet (0.4.6-0ubuntu1) maverick; urgency=low

  * New upstream release.
    * Send the activate signal down to libindicator (LP: #637692)
    * Generate AUTHORS and ChangeLog from Bazaar
  * debian/control: depends on latest libindicator-dev
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 18:08:32 +0200

Changed in indicator-applet (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package libdbusmenu - 0.3.16-0ubuntu1

---------------
libdbusmenu (0.3.16-0ubuntu1) maverick; urgency=low

  * New upstream release:
    * Don't use a typedef in the signal handler in the class to
      avoid confusing vapigen.

libdbusmenu (0.3.15-0ubuntu1) UNRELEASED; urgency=low

  * New upstream release:
    - fix Action for top-level dropdown menu item not activated (LP: #637692)
 -- Ted Gould <email address hidden> Wed, 22 Sep 2010 10:28:01 -0500

Changed in libdbusmenu (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package indicator-datetime - 0.0.6-0ubuntu2

---------------
indicator-datetime (0.0.6-0ubuntu2) maverick; urgency=low

  * Rebuild for libindicator ABI change (LP: #637692)
  * debian/control: depends on latest libindicator-dev
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 18:21:26 +0200

Changed in indicator-datetime (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package indicator-me - 0.2.10-0ubuntu1

---------------
indicator-me (0.2.10-0ubuntu1) maverick; urgency=low

  * New upstream release
    - indicator-me may crash after service restart (LP: #643906)
  * debian/control: depends on latest libindicator-dev (LP: #637692)
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 18:35:49 +0200

Changed in indicator-me (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package indicator-session - 0.2.10-0ubuntu2

---------------
indicator-session (0.2.10-0ubuntu2) maverick; urgency=low

  * Rebuild for libindicator ABI change (LP: #637692)
  * debian/control: depends on latest libindicator-dev
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 18:42:59 +0200

Changed in indicator-session (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package indicator-sound - 0.4.7-0ubuntu2

---------------
indicator-sound (0.4.7-0ubuntu2) maverick; urgency=low

  * Rebuild for libindicator ABI change (LP: #637692)
  * debian/control: depends on latest libindicator-dev
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 18:40:25 +0200

Changed in indicator-sound (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package indicator-appmenu - 0.0.12-0ubuntu1

---------------
indicator-appmenu (0.0.12-0ubuntu1) maverick; urgency=low

  * New upstream realease:
    - Fix Action for top-level dropdown menu item not activated (LP: #637692)
  * debian/control:
    - depends on latest libindicator-dev for ABI change
    - depends on latest bamf with distro patch
  * debian/rules:
    - add a patch system
  * debian/patches/01_bzr_fix_race_condition.patch:
    - This patch ensures that windows which are already closed according to bamf
      are not passed on for processing in mutter. (Jason Smith) (LP: #645355)
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 20:09:47 +0200

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package indicator-application - 0.2.9-0ubuntu1

---------------
indicator-application (0.2.9-0ubuntu1) maverick; urgency=low

  [ Ted Gould ]
  * New upstream release.
    * Fix Mono binding versioning and build (LP: #636132)
    * Fix submenus with Glade applications (LP: #608219)
    * Add new functions to Mono and Python bindings
  * debian/libappindicator0.1-cil.installcligac: Add the 0.1
    policy file.

  [ Didier Roche ]
  * debian/control:
    - build with latest libindicator-dev for ABI breakage (LP: #637692)
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 20:01:04 +0200

Changed in indicator-application (Ubuntu):
status: Fix Committed → Fix Released
Changed in indicator-appmenu (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :
Download full text (3.7 KiB)

This bug was fixed in the package unity - 0.2.42-0ubuntu1

---------------
unity (0.2.42-0ubuntu1) maverick; urgency=low

  * New upstream release:
    - "Applications" and "Files & Folders" tooltips are not translatable
      (LP: #644215)
    - Fix inactive menus are accessible on switching to a window (LP: #604505)
    - Fix wrong launcher tile label/quicklist x position (LP: #631446)
    - Fix highlighted items in quicklist have different widths (LP: #643315)
    - In migration tool, being safe when people are using crazy caracters in
      desktop file (LP: #644114, #635156)
    - Detect if 3D acceleration support is provided. Otherwise, prompt for
      logout and change default session (LP: #614088)
    - Fix quicklist shows hidden menu items (LP: #641543)
    - Fix removing launchers via dnd fails (LP: #643434)
    - Better launcher auto-scroll performances (LP: #640560)
    - Make the insensitive state of the forward- and back-button more obvious by
      decreasing their opacity, thus users don't assume they are actually
      clickable. (LP: #638285)
    - Fix some dialogs aren't maximized but are undecorated (LP: #628822)
    - Fix some menus don't go away when window closes (LP: #640557)
    - Fixes bug where the wrong icon where at times associated with a tile in
      the places view. (LP: #642935)
    - Speedup icon loading (LP: #641246)
    - Make trash menu items in Unity are either not translatable or translations
      are not loaded (LP: #645038)
    - Fix using dnd on launcher makes focus not work out of the unity ui
      (LP: #637123)
    - Multi-monitor support (LP: #637123)
    - Enable/disable super key by a gconf key (LP: #632581)
    - Remove glow on fold (LP: #619344)
    - Ensure we dont map windows when expose is active (LP: #599766)
    - take new indicator API for action for top-level dropdown menu item not
      activated (LP: #637692)
    - Make the home buttons reactive (LP: #638857)
    - Add red tint when search fails (LP: #607821)
    - New (and final!) UI adjustement, but UNE isn't in the doc as seen with
      the doc team (LP: #627009)
    - Single-touches on the launcher are usually interpreted as a drag
      (LP: #641328)
    - URI activation in global view (LP: #612562)
    - Clicking a Place icon while viewing the same place in the Dash should
      return to the Home screen of that place and clear the search (LP: #607829)
    - Fix mutter crashed with SIGSEGV in g_type_check_instance() (LP: #641561)
    - Fix panel and menu item font colors don't match (LP: #637480)
    - Fix indicators have orange color (LP: #632975)
    - Fix inactive menus are accessible on switching to a window (LP: #604505)
    - Use semi-transparent rectangle around launcher-icon (LP: #643388)
    - Fix mutter crashes when closing pop-up dialog (LP: #642669)
    - Change launcher icon reference size loading (LP: #641669)
    - Fix mutter crashing in mumble start (LP: #641335)
    - Fix clicking on a category from CoFs does not directly take you to the
      desired category (LP: #638402)
    - Fix some menus don't go away when window closes (LP: #640557)
    - Launchers should act like if the application was not focussed ...

Read more...

Changed in unity (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package indicator-messages - 0.3.11-0ubuntu2

---------------
indicator-messages (0.3.11-0ubuntu2) maverick; urgency=low

  * Rebuild for libindicator ABI change (LP: #637692)
  * debian/control: depends on latest libindicator-dev
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 18:39:27 +0200

Changed in indicator-messages (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package indicator-network - 0.2.13-0ubuntu2

---------------
indicator-network (0.2.13-0ubuntu2) maverick; urgency=low

  * Rebuild for libindicator ABI change (LP: #637692)
  * debian/control: depends on latest libindicator-dev
 -- Didier Roche <email address hidden> Wed, 22 Sep 2010 18:38:26 +0200

Changed in indicator-network (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package lxpanel - 0.5.6-0ubuntu2

---------------
lxpanel (0.5.6-0ubuntu2) maverick; urgency=low

  * debian/apport/source_lxpanel.py
   - Add apport hook.
  * debian/rules
   - Install apport hook only on Ubuntu.
  * debian/control:
   - Build-depends on lsb-release, needed to detect the distribution.
   - Build-depends on libindicator-dev (>= 0.3.14) to rebuild on lastest
     libindicator. (LP: #637692).
 -- Julien Lavergne <email address hidden> Thu, 23 Sep 2010 23:48:30 +0200

Changed in lxpanel (Ubuntu):
status: New → Fix Released
Didier Roche (didrocks) on 2010-09-24
Changed in cairo-dock-plugins (Ubuntu):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package awn-extras-applets - 0.4.0+bzr1372-0ubuntu3

---------------
awn-extras-applets (0.4.0+bzr1372-0ubuntu3) maverick; urgency=low

  * debian/control:
   - Build-depends on libindicator-dev (>= 0.3.14) to rebuild on lastest
     libindicator. (LP: #637692).
  * debian/patches/901-cairo-menu-fix-d-and-d.patch:
   - From upstream, fix drag and drop in cairo-menu. (LP: #568700)
  * debian/patches/902-mail-fix-pop-backend.patch:
   - From upstream, fix POP3 backend in mail applet (LP: #561919)
  * debian/patches/903-mail-fix-io-error.patch:
   - From upstream, unlock keyring on startup in mail applet (LP: #581075)
  * debian/patches/904-mail-fix-crash-on-toggle.patch
   - From upstream, Fix crash on_toggle() in mail applet (LP: #557410)
  * debian/patches/905-yama-fix-crash-nonetype.patch
   - From upstream, fix NoneType crash in YAMA applet (LP: #506847)
  * debian/patches/906-mail-desktop-icon.patch
   - From upstream, fix icon in desktop file of mail applet.
 -- Julien Lavergne <email address hidden> Fri, 24 Sep 2010 16:04:00 +0200

Changed in awn-extras-applets (Ubuntu):
status: New → Fix Released
Omer Akram (om26er) on 2010-09-25
Changed in unity:
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubiquity - 2.4.2

---------------
ubiquity (2.4.2) maverick; urgency=low

  [ Jonathon Riddell ]
  * gui/qt/stepLanguage.ui: nicer icons and better layout on
    language page (LP: #628808)

  [ Mario Limonciello ]
  * Set the LANG before running oem-config-remove.
  * Prevent a crash of debconf-communicate when removing oem-config.
    (LP: #641478)
  * Raise privileges when running the language page in only-installable
    mode. (LP: #647792)
  * Automatic update of included source packages: flash-kernel
    2.28ubuntu10.

  [ Evan Dandrea ]
  * Don't let Jockey's automatic driver installation failing cause the
    entire prepare page to fail.
  * Make sure $LANGUAGE gets set in the parallel debconf child process,
    so that we get translated descriptions (LP: #646109).
  * Set the effective UID in regain_privileges_save so we don't try to
    setgroups([]) as a regular user (LP: #646827).

  [ Didier Roche ]
  * depends on latest libindicator-dev for ABI change (LP: #637692, #647739)
 -- Mario Limonciello <email address hidden> Sat, 25 Sep 2010 18:24:06 -0500

Changed in ubiquity (Ubuntu):
status: New → Fix Released
Adam Dingle (adam-yorba) wrote :

I'm still seeing this problem on Ubuntu 10.10 with all the latest updates as of September 27. Many Shotwell menu items are not available when they should be, making Shotwell pretty much unusable on Unity.

I'm seeing the same thing with Scribus-trunk, a Qt app, when it's
running on the Gnome desktop with either the app-menu panel applet, or
Unity. Aurelien says it works fine under KDE. I wonder if it's the same
problem?

Mark

Ted Gould (ted) wrote :

This is working the way that I think it should... could you post a screenshot as I seem to have the items disabled now. Perhaps I'm not understanding what I'm looking for.

Thanks, Ted.

Jim Nelson (yorba-jim) wrote :

The problem is that if you select photo(s) in Shotwell, most/almost all of them items in the Photos drop-down menu remain inactive. They should be active when photos are selected.

I've attached a screenshot showing the problem. All of the items in Photos should be available at this point (because some photos are selected).

Changed in shotwell:
status: New → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.